Codeforces-831C Jury Marks(暴力)

来源:互联网 发布:熊掌好吃吗 知乎 编辑:程序博客网 时间:2024/06/06 07:44
C. Jury Marks
time limit per test
2 seconds
memory limit per test
256 megabytes
input
standard input
output
standard output

Polycarp watched TV-show where k jury members one by one rated a participant by adding him a certain number of points (may be negative, i. e. points were subtracted). Initially the participant had some score, and each the marks were one by one added to his score. It is known that the i-th jury member gave ai points.

Polycarp does not remember how many points the participant had before this k marks were given, but he remembers that among the scores announced after each of the k judges rated the participant there were n (n ≤ k) values b1, b2, ..., bn (it is guaranteed that all values bj are distinct). It is possible that Polycarp remembers not all of the scores announced, i. e. n < k. Note that the initial score wasn't announced.

Your task is to determine the number of options for the score the participant could have before the judges rated the participant.

Input

The first line contains two integers k and n (1 ≤ n ≤ k ≤ 2 000) — the number of jury members and the number of scores Polycarp remembers.

The second line contains k integers a1, a2, ..., ak ( - 2 000 ≤ ai ≤ 2 000) — jury's marks in chronological order.

The third line contains n distinct integers b1, b2, ..., bn ( - 4 000 000 ≤ bj ≤ 4 000 000) — the values of points Polycarp remembers. Note that these values are not necessarily given in chronological order.

Output

Print the number of options for the score the participant could have before the judges rated the participant. If Polycarp messes something up and there is no options, print "0" (without quotes).

Examples
input
4 1-5 5 0 2010
output
3
input
2 2-2000 -20003998000 4000000
output
1
Note

The answer for the first example is 3 because initially the participant could have  - 1010 or 15 points.

In the second example there is only one correct initial score equaling to 4 002 000.


题意:一个比赛中,n裁判依次给你打分,第i个裁判给了A[i]分,但你记性不好,没有记住所有得分,连初始分都忘记了,只记得m个加完分后的总分B[i](不是按顺序的),且B[i]互不相同。问:初始分有多少种可能的情况。


题解:暴力出奇迹~~~
首先把裁判给的分数的前缀和sum求出来,因为Bi是互不相同的,因此sum中可以直接把重复的去除掉。

由于并不是按顺序记住分数B[i],设初始分数为start,只要找出是否存在得分前缀和满足sum[k]=B[i]-start,对于每个start只要使每个B[i]都有一个前缀和对应,则这个start是满足条件的。

枚举start的方法也很简单:枚举每个前缀和sum[i],start=B[1]-sum[i](因为B[1]一定要匹配上某个前缀和的,所以枚举与它匹配的前缀和就相当于枚举所有可能的start)

#include<bits/stdc++.h>#define lson l,m,rt<<1#define rson m+1,r,rt<<1|1using namespace std;const int LL = 0x3f3f3f3f;const int mod = 1e9 + 7;const int MX = 2e3 + 5;int sum[MX],b[MX];bool vis[MX];const int base = 1e7 + 5;int H[base*2];int main(){    //freopen("in.txt","r",stdin);    int n,m;    while(~scanf("%d%d",&n,&m)){        for(int i=1;i<=n;++i) {            scanf("%d",&sum[i]);            sum[i]+=sum[i-1];            H[sum[i]+base]=1;        }        for(int i=1;i<=m;++i) scanf("%d",&b[i]);        sort(sum+1,sum+n+1);        //因为b中的数两两不相等,因此前缀和中可以删去相同项        n=unique(sum+1,sum+n+1)-sum-1;        int cnt=0;        for(int i=1;i<=n;i++){            int num=0,s=b[1]-sum[i];            for(int j=1;j<=m;j++){                num+=H[b[j]-s+base];  //是否存在一个k使得sum[k]=b[j]-s            }            //若有m个k满足sum[k]=b[j]-s,则方案数+1            if(num==m) cnt++;        }        printf("%d\n",cnt);    }    return 0;}


原创粉丝点击